/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/



#include	"xl.h"


int
list_length(XL_SEXP * s)
{
int ret;
	ret = 0;
	for ( ; ; s = cdr(s), ret ++ ) {
		switch ( get_type(s) ) {
		case XLT_ERROR:
			return -1;
		case XLT_NULL:
			return ret;
		}
	}
}
